# Using wolfSSL with uTasker

This directory contains:

**wolfSSLClientTask.c** - Example wolfSSL uTasker Client Task
**wolfSSLServerTask.c** - Example wolfSSL uTasker Server Task


## Introduction

wolfSSL is happy to announce that the wolfSSL embedded SSL/TLS and wolfCrypt cryptography libraries have been ported to the uTasker operating system.

[uTasker](http://www.utasker.com/) is an operating system, stack, and collection of services designed for embedded devices.  It includes an OS, filesystem, device drivers, and TCP/IP stack among other features.  The uTasker package includes a device simulator, allowing developers to test and debug code faster than would be possible on physical hardware itself.  Complete details on the uTasker stack can be found on the project website: http://www.utasker.com/.

This document describes the wolfSSL uTasker port and how to use wolfSSL in a uTasker-based project to secure socket connections.  This document should act as a supplement to the [wolfSSL Manual](https://wolfssl.com/wolfSSL/Docs-wolfssl-manual-toc.html).

## Documentation

Documentation on using the [wolfSSL](https://www.wolfssl.com) embedded SSL/TLS library with uTasker can be found on the wolfSSL website here:

[Using wolfSSL with uTasker](https://wolfssl.com/wolfSSL/Docs-wolfssl-utasker.html)

## Support

Please contact wolfSSL at support@wolfssl.com with any questions or bug fixes.

